:: ==========================================================================================================================
:: ====================================== USB_MultiBoot2.cmd ================================================================
:: ==========================================================================================================================
@ECHO OFF
CLS

SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
IF EXIST usb_prep.log (del usb_prep.log)

(
  ECHO.
  ECHO  Program  -  USB_MultiBoot2.cmd  -  05 feb 2008 - Date = %DATE% %TIME:~0,8%
  ECHO  Prepares MultiBoot USB-Drive provided with Windows XP Setup LocalSource 
  ECHO  Supports Booting: MS-DOS  FREEDOS  BartPE  WinPE 2.0 and Setup Windows XP
  ECHO  Supports GRUB4DOS with DOS FLOPPY IMAGES + Linux and Supports SYSLINUX Menu
  ECHO.
  ECHO  *** BEFORE YOU START: ***  Use 2 GB USB-stick with High Read/Write Speed
  ECHO  First Format to Make Bootable USB-stick with FAT FileSystem, FAT = Faster
  ECHO  such that USB-stick has NTLDR Bootsector and is seen by BIOS as Harddisk 
  ECHO  PeToUSB Settings:
  ECHO  To Format USB-Drive  : Enable Disk Format with LBA FAT16X
  ECHO  For Install of BartPE: Give BartPE Source Path and Enable FileCopy
  ECHO.
  ECHO  OR Use Existing USB-stick with NTLDR Bootsector and Multi boot.ini Menu
  ECHO  GUIDE: http://www.911cd.net/forums//index.php?showtopic=20089 
  ECHO  For AUTOSTART: COPY PeToUSB.exe in your USB_MultiBoot2 folder
  ECHO  PeToUSB Download http://gocoding.com/page.php?al=petousb
  ECHO.
  ECHO  For UNATTENDED XP Install make Changes in USB_MultiBoot2 folder:
  ECHO  Change Product Key in winnt.sif and Change $OEM$ folder to your needs
  ECHO.
  ECHO  FOR USB-Harddisk make 1900 MB partition at beginning of the USB-Harddisk
  ECHO  Use FAT Format and Set Active OR use PeToUSB to Format such partition
  ECHO  ============================================================================= 
) | tee.bat -a usb_prep.log

PAUSE

:: Check Windows version
IF NOT "%OS%"=="Windows_NT"  (
  ECHO.
  ECHO ***** ONLY for Windows XP OR Windows 2003 *****
  ECHO.
  ECHO >> usb_prep.log ***** ONLY for Windows XP OR Windows 2003 *****
  GOTO :_end_quit
)


IF EXIST PeToUSB.exe ( 
   PeToUSB.exe
   ECHO.>> usb_prep.log
   ECHO >> usb_prep.log PeToUSB.exe was launched to FORMAT USB-Drive
   ECHO.>> usb_prep.log
)

set usb_type=USB-stick
set xpsource=
set usbconfg=U_CONTENT
set usbdrive=
set usb_temp=usb_xpbt
set logtype=Simple
set _mypath=%~dp0
set drlist=
set drfat=


:_main
echo.
echo.
echo  Program - USB_MultiBoot2.cmd - 05 feb 2008 - Date = %DATE% %TIME:~0,8%
echo.
echo.
echo  Prepares MultiBoot USB-Drive provided with Windows XP Setup LocalSource
echo.
echo     0) Change Type of USB-Drive,    currently [%usb_type%]
echo.
echo     1) Change XP Setup Source Path, currently [%xpsource%]
echo.
echo     2) Change USB Content Source,   currently [%usbconfg%]
echo.
echo     3) Change USB-Drive Target,     currently [%usbdrive%]
echo.
echo     4) Make MultiBoot USB-Drive and Copy XP and Content Source to USB-Drive
echo.
echo     F) Change Log File - Simple OR Extended, currently [%logtype%]
echo.
echo     Q) Quit
echo.
echo.
echo.
echo.

set _ok=
set /p _ok= Enter your choice: 
if "%_ok%" == "0" goto _getype
if "%_ok%" == "1" goto _getsrc
if "%_ok%" == "2" goto _getcfg
if "%_ok%" == "3" goto _getusb
if "%_ok%" == "4" goto _mktemp
if /I "%_ok%" == "f" goto _getlog
if /I "%_ok%" == "q" goto _end_quit
ECHO.
ECHO ***** NOT in Menu - Wrong Selection - Try Again *****
ECHO.
pause
goto :_main

:_getype
IF "%usb_type%" == "USB-stick" (
    set usb_type=USB-Harddisk
) ELSE (
    set usb_type=USB-stick
)
goto _main

:_getlog
IF "%logtype%" == "Simple" (
   set logtype=Extended
) ELSE (
   set logtype=Simple
)
goto _main

:_getsrc
set src_ok=
echo.
echo  Please give the location to your Windows XP Setup Source Files

IF EXIST u_script\FolderSel.vbs (
  FOR /F "tokens=*" %%A IN ('CSCRIPT.EXE //NoLogo u_script\FolderSel.vbs') DO SET src_ok=%%A
) ELSE (
  ECHO  e.g if you have D:\XPSOURCE\I386 type D:\XPSOURCE
  set /p src_ok= Enter Source path: 
)
ECHO.

if exist %src_ok%\I386\DOSNET.INF (
        SET xpsource=%src_ok%
) else (
	echo.
	echo  Error: The path %src_ok% does not contain Windows XP Source Files
        echo.
	pause
)
goto _main

:_getcfg
set src_ok=
echo.
echo  Please give the location to your USB Content Source Folder

IF EXIST u_script\FolderSel.vbs (
  FOR /F "tokens=*" %%A IN ('CSCRIPT.EXE //NoLogo u_script\FolderSel.vbs') DO SET src_ok=%%A
) ELSE (
  ECHO  e.g if you have D:\U_CONTENT type D:\U_CONTENT
  set /p src_ok= Enter USB Content Source Path: 
)
ECHO.

if exist %src_ok%\usbflash (
        SET usbconfg=%src_ok%
) else (
	echo.
	echo  Error: The path %src_ok% does not contain USB Content Source Files
        echo.
	pause
)
goto _main

:_getusb
set _ok=
set drfat=
SET usbdrive=

FOR /F "tokens=*" %%a in ('fsutil fsinfo drives ^| FIND /V ""') DO (
  set dr=%%a
  call set drlist=%%drlist%% %%dr:~-3,2%%
  FOR /F "tokens=*" %%G IN ('fsutil fsinfo volumeinfo !dr! ^| FIND "FAT" ^| FIND /V "FAT32"') DO ( 
    call set drfat=%%drfat%% %%dr:~-3,2%%
  )
)
echo.
echo  Please Select Target USB-Drive Letter from Drives %drfat% with FAT Format
ECHO.
set /p _ok= Enter Target USB-Drive Letter: 
set _ok=!_ok:~0,1!

:: Convert Drive Letter to Uppercase
set /A chtel=0
set /A uptel=0
FOR %%i IN (d e f g h i j k l m n o p q r s t u v w x y z) DO (
  set /A chtel=!chtel!+1
  IF "%%i" == "!_ok!" (
    FOR %%i IN (D E F G H I J K L M N O P Q R S T U V W X Y Z) DO (
      set /A uptel=!uptel!+1
      IF "!uptel!" == "!chtel!" (
         SET _ok=%%i
         goto _ucase
      )
    )
  )
)

:_ucase

FOR %%i IN (%drfat%) DO IF "%%i" == "!_ok!:" SET usbdrive=!_ok!:

if "%usbdrive%" == "" ( 
        echo.
        echo  ***** !_ok!: Drive does NOT have FAT Format and is NOT Valid *****
        echo.
	pause
	goto _main
)

if EXIST %usbdrive%\$WIN_NT$.~LS\I386\nul (
        echo.
	echo  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo  ***** Files will be Replaced when XP Source is Copied to USB-Drive *****
        echo.
        echo.>> usb_prep.log
	echo >> usb_prep.log  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo >> usb_prep.log  ***** Files will be Replaced when XP Source is Copied to USB-Drive *****
        echo.>> usb_prep.log
	pause
)
goto _main

:_mktemp
IF "%xpsource%" == "" (
        echo.
        echo  ***** Please give first valid XP Source Path *****
        echo.
	pause
	goto _main
)

IF "%usbconfg%" == "" (
        echo.
        echo  ***** Please give first valid USB Content Source Path *****
        echo.
	pause
	goto _main
)

IF "%usbdrive%" == "" (
        echo.
        echo  ***** Please give first valid Target USB-Drive Letter *****
        echo.
	pause
	goto _main
)

IF "%usbdrive%" == "!usbconfg:~0,2!" (
        echo.
        echo  ***** ERROR - Target and Source are Equal Drives - Make Changes *****
        echo.
	pause
	goto _main
)

IF "%usbdrive%" == "!xpsource:~0,2!" (
        echo.
        echo  ***** ERROR - Target and Source are Equal Drives - Make Changes *****
        echo.
	pause
	goto _main
)

:: Last Check to be Certain it is a Drive with FAT Format

set drfat=
FOR /F "tokens=*" %%a in ('fsutil fsinfo drives ^| FIND /V ""') DO (
  set dr=%%a
  call set drlist=%%drlist%% %%dr:~-3,2%%
  FOR /F "tokens=*" %%G IN ('fsutil fsinfo volumeinfo !dr! ^| FIND "FAT" ^| FIND /V "FAT32"') DO ( 
    call set drfat=%%drfat%% %%dr:~-3,2%%
  )
)
FOR %%i IN (%drfat%) DO IF "%%i" == "%usbdrive%" goto _mkmulti
goto _main


:: ==========================================================================================================================
:: ================= PART 1 - Preparing usb_temp Temporary Folder usb_xpbt  =================================================
:: ==========================================================================================================================

:_mkmulti
(
  echo.
  echo  Drive Settings
  echo  drives = %drlist%
  echo  fatlist = %drfat%
  echo  mkbtpath = %_mypath%
  echo.
  echo  usb_type = %usb_type%
  echo  xpsource = %xpsource%
  echo  usbconfg = %usbconfg%
  echo  usbdrive = %usbdrive%
  echo  usb_temp = %usb_temp%
  echo.
) | tee.bat -a usb_prep.log

ECHO.
ECHO  *** Make Temporary Folder %usb_temp% with Custom XP Setup BootFiles ***
ECHO.
ECHO  Parse DOSNET.INF for making Windows XP Setup Bootfolder $WIN_NT$.~BT
ECHO.
ECHO.>> usb_prep.log
ECHO.>> usb_prep.log Date = !DATE! !TIME:~0,8!
ECHO.>> usb_prep.log
ECHO >> usb_prep.log *** Make Temporary Folder %usb_temp% with Custom XP Setup BootFiles ***
ECHO.>> usb_prep.log
ECHO >> usb_prep.log Parse DOSNET.INF for making Windows XP Setup Bootfolder $WIN_NT$.~BT
ECHO.>> usb_prep.log

SET xpdir=\I386
SET btdir=$WIN_NT$.~BT

IF EXIST %usb_temp%\nul rd /S /Q %usb_temp%

IF NOT EXIST %usb_temp%\nul MD %usb_temp%
:: Make Destination directories for XP Setup Bootfolder
IF NOT EXIST %usb_temp%\%btdir%\nul MD %usb_temp%\%btdir%
IF NOT EXIST %usb_temp%\%btdir%\system32\nul MD %usb_temp%\%btdir%\system32
IF NOT EXIST %usb_temp%\$WIN_NT$.~LS\nul MD %usb_temp%\$WIN_NT$.~LS
IF NOT EXIST %usb_temp%\$WIN_NT$.~LS\I386\nul MD %usb_temp%\$WIN_NT$.~LS\I386

SET cpyflag=0
SET /A dtel=0
FOR /F "tokens=1,2* delims== " %%G IN (%xpsource%\I386\DOSNET.INF) DO (
  SET FTAG=%%G
  IF "!FTAG!"=="[Directories]" ( 
    SET cpyflag=1
  ) ELSE (
    SET FTAG=!FTAG:~0,1!
    IF "!FTAG!"=="[" SET cpyflag=0
    IF "!cpyflag!"=="1" (
      SET /A dtel=!dtel! + 1
      SET __xpdir.!dtel!=%%H
    ) 
  )
)

SET cpyflag=0
FOR /F "tokens=1,2,3* delims=, " %%G IN (%xpsource%\I386\DOSNET.INF) DO (
  SET FTAG=%%G
  SET FTAG=!FTAG:~0,13!
  IF "!FTAG!"=="[FloppyFiles." ( 
    SET cpyflag=1
    IF "%%G"=="[FloppyFiles.x]" SET cpyflag=0
  ) ELSE (
    SET FTAG=!FTAG:~0,1!
    IF "!FTAG!"=="[" SET cpyflag=0
    IF "!cpyflag!"=="1" (
      SET dnum=%%G
      SET dnum=!dnum:~1,1!
      IF "!dnum!"=="1" SET xpdir=%__xpdir.1%
      IF "!dnum!"=="2" SET xpdir=%__xpdir.2%
      IF "!dnum!"=="3" SET xpdir=%__xpdir.3%
      IF "!dnum!"=="4" SET xpdir=%__xpdir.4%
      SET btfile=%%H
      IF "%%I"=="" (
         SET btfile=!btfile:~0,-1!*
         IF "%logtype%" == "Simple" (
           xcopy %xpsource%!xpdir!\!btfile! %usb_temp%\%btdir% /i /k /y /h
         ) ELSE (
           xcopy %xpsource%!xpdir!\!btfile! %usb_temp%\%btdir% /i /k /y /h | tee.bat -a usb_prep.log
         )
      ) ELSE (
         IF "%logtype%" == "Simple" (
           copy /y %xpsource%!xpdir!\%%H %usb_temp%\%btdir%\%%I
         ) ELSE (
           copy /y %xpsource%!xpdir!\%%H %usb_temp%\%btdir%\%%I | tee.bat -a usb_prep.log
         )
      )
    ) 
  )
)

IF EXIST %usb_temp%\%btdir%\NTLDR DEL %usb_temp%\%btdir%\NTLDR
ECHO.
ECHO  Making Windows XP Setup Bootfolder %usb_temp%\%btdir% - READY
ECHO.>> usb_prep.log
ECHO >> usb_prep.log Making Windows XP Setup Bootfolder %usb_temp%\%btdir% - READY
ECHO.>> usb_prep.log Date = !DATE! !TIME:~0,8!
ECHO.>> usb_prep.log
ECHO.
ECHO  Copying Custom files and XP Root files to Temporary Folder %usb_temp% ....
ECHO.
xcopy makebt\binifix4.cmd %usb_temp%\$WIN_NT$.~LS\I386 | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy makebt\migrate.inf %usb_temp%\$WIN_NT$.~BT\ /y | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
IF EXIST %xpsource%\OEM\bin\DPsFnshr.7z (
  copy /y winnt_dp.sif %usb_temp%\$WIN_NT$.~BT\winnt.sif | tee.bat -a usb_prep.log
) ELSE (
  copy /y winnt.sif %usb_temp%\$WIN_NT$.~BT\winnt.sif | tee.bat -a usb_prep.log
)
ECHO.>> usb_prep.log
ECHO.
xcopy makebt\ren_fold.cmd %usb_temp%\$WIN_NT$.~LS\I386 | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy makebt\undoren.cmd %usb_temp%\$WIN_NT$.~LS\I386 | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy makebt\boot.ini %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %xpsource%\i386\txtsetup.sif %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %xpsource%\i386\bootfont.bin %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %xpsource%\i386\ntdetect.com %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %xpsource%\i386\ntldr %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %xpsource%\i386\setupldr.bin %usb_temp%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
ECHO >> usb_prep.log Custom files and XP Root files Copied to Temporary Folder %usb_temp% Ready
ECHO.>> usb_prep.log

ECHO.
ECHO  Adding lines to TXTSETUP.SIF ....

makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "ren_fold.cmd = 100,,,,,,_x,2,0,0" -s SourceDisksFiles
makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "undoren.cmd = 100,,,,,,_x,2,0,0" -s SourceDisksFiles
makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "binifix4.cmd = 100,,,,,,_x,2,0,0" -s SourceDisksFiles

:: Added for USB hard drives, loads rdummy.sys during Text Setup, which makes usbstor to see USB HD-drives as removable
IF "%usb_type%" == "USB-Harddisk" (
   makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "rdummy.sys = 1,,,,,,4_,4,1,,,1,4" -s SourceDisksFiles
   makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "rdummy = rdummy.sys,4" -s SCSI.Load
   makebt\fedit -f %usb_temp%\txtsetup.sif -add -once -l "rdummy = \"USB hard disk as removable\"" -s SCSI
   makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -add -create -l "\"sc config rdummy start= disabled"" -s GuiRunOnce
   ECHO >> usb_prep.log Adding rdummy.sy_ to make Fixed USB-Harddisk seen in XP Setup as Removable Device
   copy makebt\rdummy.sy_ %usb_temp%\$WIN_NT$.~LS\I386 | tee.bat -a usb_prep.log
   copy makebt\rdummy.sy_ %usb_temp%\$WIN_NT$.~BT | tee.bat -a usb_prep.log
)

ECHO.>> usb_prep.log
ECHO >> usb_prep.log Adding lines to TXTSETUP.SIF Ready

ECHO.
ECHO  Adding lines to WINNT.SIF ....

makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -add -create -l "\"undoren.cmd"" -s GuiRunOnce
makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -add -create -l "\"binifix4.cmd c:"" -s GuiRunOnce
makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -add -create -l "UserExecute = \"ren_fold.cmd\"" -s SetupParams
makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -rem -l:o = -s unattended
makebt\fedit -f %usb_temp%\$WIN_NT$.~BT\winnt.sif -rem -l [unattended]
ECHO.
ECHO.>> usb_prep.log
ECHO >> usb_prep.log Adding lines to WINNT.SIF Ready
ECHO.>> usb_prep.log

:: $OEM$\CMDLINES.TXT is used for making UserAccounts and install of Registry Tweaks at T-12
:: Info see: http://unattended.msfn.org/unattended.xp/   Reference

ECHO  Adding $OEM$ folder with UserAccounts and Registry Tweaks if present ....
IF EXIST $OEM$\nul (
   xcopy $OEM$\*.* %usb_temp%\$WIN_NT$.~LS\$OEM$\ /i /k /e /y /h | tee.bat -a usb_prep.log
   ECHO >> usb_prep.log Adding $OEM$ folder with UserAccounts and Registry Tweaks Ready
)
ECHO.

ECHO  Adding OEM folder with BTS DriverPacks if they were used ....
IF EXIST %xpsource%\OEM\bin\DPsFnshr.7z (
   ECHO.>> usb_prep.log
   xcopy %xpsource%\OEM %usb_temp%\OEM /i /k /e /y /h | tee.bat -a usb_prep.log
   echo >> usb_prep.log Adding OEM folder with BTS DriverPacks Ready
   ECHO.>> usb_prep.log
)

IF EXIST %xpsource%\I386\presetup.cmd (
   ECHO  Adding Custom presetup.cmd for BTS DriverPacks ....
   echo.>> usb_prep.log
   xcopy makebt\presetup.cmd %usb_temp%\$WIN_NT$.~LS\I386\ /y | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
   ECHO >> usb_prep.log presetup.cmd could give Windows ERROR Alert: No Disk due to Cardreader, Use Continue XP Setup
   ECHO >> usb_prep.log presetup.cmd was changed to limit the range for Finding Drives with OEM TAGFILE
   ECHO >> usb_prep.log presetup.cmd was changed to Delete setupold.exe , necessary for Repair Install Windows XP option
)

ECHO.
ECHO  *** Make Temporary Folder %usb_temp% with Custom XP Setup BootFiles Ready ***
ECHO.>> usb_prep.log
ECHO >> usb_prep.log *** Make Temporary Folder %usb_temp% with Custom XP Setup BootFiles Ready ***

:: ==========================================================================================================================
:: ======== PART 2 - Backup Bootsector Files, Copy USB Content Source to USB-Drive, Make BootSector Files ===================
:: ==========================================================================================================================

if EXIST %usbdrive%\$WIN_NT$.~LS\nul (
        echo.
	echo  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo  ***** Files will be Replaced when XP Source is Copied to USB-Drive *****
        echo.
        echo  *** Update USB-Drive with Total Commander Synchronize Dirs Asymmetric **
        echo.
        echo.>> usb_prep.log
	echo >> usb_prep.log  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo >> usb_prep.log  ***** Files will be Replaced when XP Source is Copied to USB-Drive *****
        echo.>> usb_prep.log  
        echo >> usb_prep.log  *** Update USB-Drive with Total Commander Synchronize Dirs Asymmetric **
        echo.>> usb_prep.log
) 

(
  ECHO.
  ECHO  Copy XP Source To USB-Drive - about 15 minutes
  ECHO.
  ECHO  Yes = Copy XP + USB Content Source Folder To USB-Drive
  ECHO  No  = Only Copy USB Content Source Folder To USB-Drive
  ECHO  Cancel = STOP - End Program
  ECHO.
) | tee.bat -a usb_prep.log 

set copyxp=y
  
IF EXIST u_script\Msg_CopyXPToUSB.vbs (
     FOR /F "tokens=*" %%A IN ('CSCRIPT.EXE //NoLogo u_script\Msg_CopyXPToUSB.vbs') DO SET Conf=%%A
     IF "!Conf!"=="6" SET copyxp=y
     IF "!Conf!"=="7" SET copyxp=n
     IF "!Conf!"=="2" SET copyxp=c
  ) ELSE (
    SET /P Conf= Copy XP Source to USB-Drive ?  Select Yes / No / Cancel  Please enter y / n / c:
    SET copyxp=!Conf:~0,1! 
  )
  IF /I !copyxp!.==c. GOTO _end_quit
ECHO.

ECHO  Making Backups on USB-Drive and Preparing for FileCopy ....
ECHO.>> usb_prep.log
ECHO >> usb_prep.log Making Backups on USB-Drive and Preparing for FileCopy ....
ECHO.>> usb_prep.log

IF EXIST %usbdrive%\boot.ini (
   ATTRIB -h -r -s %usbdrive%\boot.ini
   copy /y %usbdrive%\boot.ini %usbdrive%\boot_ini_bak.txt | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
   ECHO.
)
IF EXIST %usbdrive%\Bootfont.bin ATTRIB -h -r -s %usbdrive%\Bootfont.bin
IF EXIST %usbdrive%\NTDETECT.COM ATTRIB -h -r -s %usbdrive%\NTDETECT.COM
IF EXIST %usbdrive%\ntldr ATTRIB -h -r -s %usbdrive%\ntldr

IF EXIST %usbdrive%\BackupBS.ori (
   ATTRIB -h -r -s %usbdrive%\BackupBS.ori
   copy /y %usbdrive%\BackupBS.ori %usbdrive%\BackupBS_ori.bak | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
   del %usbdrive%\BackupBS.ori
)

IF EXIST %usbdrive%\SETUPLDR.bs (
   ATTRIB -h -r -s %usbdrive%\SETUPLDR.bs
   ECHO.>> usb_prep.log
)

IF EXIST %usbdrive%\btsec\BackupBS.ori (
   ATTRIB -h -r -s %usbdrive%\btsec\BackupBS.ori
   copy /y %usbdrive%\btsec\BackupBS.ori %usbdrive%\btsec\BackupBS_ori.bak | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
   del %usbdrive%\btsec\BackupBS.ori
)

IF EXIST %usbdrive%\btsec\NTBOOT.bs copy /y %usbdrive%\btsec\NTBOOT.bs %usbdrive%\btsec\NTBOOT_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\SETUPLDR.bs copy /y %usbdrive%\btsec\SETUPLDR.bs %usbdrive%\btsec\SETUPLDR_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\PELDR.bs copy /y %usbdrive%\btsec\PELDR.bs %usbdrive%\btsec\PELDR_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\BOOTMGR.bs copy /y %usbdrive%\btsec\BOOTMGR.bs %usbdrive%\btsec\BOOTMGR_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\MSBOOT.bs copy /y %usbdrive%\btsec\MSBOOT.bs %usbdrive%\btsec\MSBOOT_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\FDBOOT.bs copy /y %usbdrive%\btsec\FDBOOT.bs %usbdrive%\btsec\FDBOOT_bs.bak | tee.bat -a usb_prep.log
IF EXIST %usbdrive%\btsec\SLBOOT.bs copy /y %usbdrive%\btsec\SLBOOT.bs %usbdrive%\btsec\SLBOOT_bs.bak | tee.bat -a usb_prep.log

ECHO.
ECHO  Copy Files to USB-Drive Start - Date = %DATE% %TIME:~0,8%
ECHO.>> usb_prep.log
ECHO >> usb_prep.log Copy Files to USB-Drive Start - Date = %DATE% %TIME:~0,8%
echo.>> usb_prep.log
ECHO.

IF "%logtype%" == "Simple" (
  ECHO  Date = !DATE! !TIME:~0,8!
  ECHO  USB Content Source Folder           Copy to USB-Drive is Running ....
  echo >> usb_prep.log USB Content Source Folder   Copy to USB-Drive Begin   Date = !DATE! !TIME:~0,8!
  xcopy %usbconfg%\*.* %usbdrive%\  /i /k /e /r /y /h
  echo >> usb_prep.log USB Content Source Folder   Copy to USB-Drive Ready   Date = !DATE! !TIME:~0,8!
  ECHO.>> usb_prep.log
) ELSE (
  ECHO  Date = !DATE! !TIME:~0,8!
  ECHO  USB Content Source Folder           Copy to USB-Drive is Running ....
  ECHO  Please Wait about 15 minutes .....  STOP with [Ctrl][C] 
  echo >> usb_prep.log USB Content Source Folder   Copy to USB-Drive Begin   Date = !DATE! !TIME:~0,8!
  xcopy %usbconfg%\*.* %usbdrive%\  /i /k /e /r /y /h | tee.bat -a usb_prep.log
  echo >> usb_prep.log USB Content Source Folder   Copy to USB-Drive Ready   Date = !DATE! !TIME:~0,8!
  ECHO.>> usb_prep.log
)
echo.
echo  USB Content Source Folder   Copy to USB-Drive Ready
ECHO  Date = !DATE! !TIME:~0,8!
echo.

IF EXIST %usbdrive%\boot.ini (
   ATTRIB -h -r -s %usbdrive%\boot.ini
   copy /y %usbdrive%\boot.ini %usbdrive%\boot_ini_cfg.txt | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
   ECHO.
)

ECHO  >> usb_prep.log Copy XP BootFiles .....
echo.
ECHO Copy XP BootFiles .....
xcopy %usb_temp%\boot.ini %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.
xcopy %usb_temp%\bootfont.bin %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.
xcopy %usb_temp%\ntdetect.com %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.
xcopy %usb_temp%\ntldr %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.
echo. >> usb_prep.log
echo >> usb_prep.log Copy BartPE minint\setupldr.bin as peldr and Hexedit peldr with gsar .....
echo Copy BartPE minint\setupldr.bin as peldr and Hexedit peldr with gsar .....

if exist %usbdrive%\minint\setupldr.bin (
  copy /y %usbdrive%\minint\setupldr.bin %usbdrive%\peldr | tee.bat -a usb_prep.log
  copy /y %usbdrive%\peldr %usbdrive%\peldr.bak | tee.bat -a usb_prep.log
  makebt\gsar -sBT:x00:x00:x00\:x00:x00:x00txtsetup -rBT:x00:x00:x00\:x00:x00:x00notsetup %usbdrive%\peldr %usbdrive%\peldr.new -b -f | tee.bat -a usb_prep.log
  if exist %usbdrive%\peldr.new copy /y %usbdrive%\peldr.new %usbdrive%\peldr | tee.bat -a usb_prep.log
  if exist %usbdrive%\peldr.new del %usbdrive%\peldr.new
)
ECHO.
echo. >> usb_prep.log
echo.

IF NOT EXIST %usbdrive%\btsec\nul MD %usbdrive%\btsec


ECHO  >> usb_prep.log Make Bootsector Files in btsec Folder ....
ECHO  Make Bootsector Files in btsec Folder ....
ECHO.
CALL makebt\makeBS2.cmd %usbdrive%\SETUPLDR.BIN
CALL makebt\makeBS2.cmd %usbdrive%\PELDR
:: CALL makebt\makeBS2.cmd %usbdrive%\BOOTMGR
makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\NTBOOT.bs | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
:: makebt\mkbt.exe -x makebt\bs_setup.bin %usbdrive% | tee.bat -a usb_prep.log
:: if errorlevel 1 goto :_mkbterror
:: makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\SETUPLDR.bs | tee.bat -a usb_prep.log
:: if errorlevel 1 goto :_mkbterror
:: makebt\mkbt.exe -x makebt\bs_peldr.bin %usbdrive% | tee.bat -a usb_prep.log
:: if errorlevel 1 goto :_mkbterror
:: makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\PELDR.bs | tee.bat -a usb_prep.log
:: if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x makebt\bs_btmgr.bin %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\BOOTMGR.bs | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x makebt\bs_msdos.bin %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\MSBOOT.bs | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x %usbdrive%\btsec\NTBOOT.bs %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x makebt\bs_frdos.bin %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\FDBOOT.bs | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x %usbdrive%\btsec\NTBOOT.bs %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\syslinux.exe -f %usbdrive%
makebt\mkbt.exe -x -c %usbdrive% %usbdrive%\btsec\SLBOOT.bs | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
makebt\mkbt.exe -x %usbdrive%\btsec\NTBOOT.bs %usbdrive% | tee.bat -a usb_prep.log
if errorlevel 1 goto :_mkbterror
ECHO.
echo  Bootsector Files for XP Setup, BartPE, Win PE, DOS and SYSLINUX were Made
echo.>> usb_prep.log
echo >> usb_prep.log Bootsector Files for XP Setup, BartPE, Win PE, DOS and SYSLINUX were Made
ECHO.>> usb_prep.log
ECHO.


goto :_copyxp

:_mkbterror
ECHO >> usb_prep.log ***** ERROR in making Bootsector Files with MKBT *****
ECHO  ***** ERROR in making Bootsector Files with MKBT *****
IF EXIST %usbdrive%\btsec\BackupBS.ori makebt\mkbt.exe -x %usbdrive%\btsec\BackupBS.ori %usbdrive% | tee.bat -a usb_prep.log
:: IF EXIST %usbdrive%\btsec\NTBOOT.bs makebt\mkbt.exe -x %usbdrive%\btsec\NTBOOT.bs %usbdrive% | tee.bat -a usb_prep.log


:: ==========================================================================================================================
:: ================= PART 3 - Copy XP Source to USB-Drive ===================================================================
:: ==========================================================================================================================

:_copyxp

IF /I !copyxp!.==n. (
  IF EXIST u_script\Msg_NOXP.vbs CSCRIPT.EXE //NoLogo u_script\Msg_NOXP.vbs
  GOTO _end_mig
)

set Confirm=y

if EXIST %usbdrive%\$WIN_NT$.~LS\nul (
        echo.
	echo  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo.
        echo  Yes = Replace Files by Copy of XP Source to USB-Drive - 15 minutes
        echo  No  = Stop - Update USB-Drive with Total Commander Synchronize Dirs Asymmetric
        echo.
        echo.>> usb_prep.log
	echo >> usb_prep.log  ***** WARNING Existing Folder $WIN_NT$.~LS on USB-Drive Detected   *****
        echo.>> usb_prep.log  
        echo >> usb_prep.log  Yes = Replace Files by Copy of XP Source to USB-Drive - 15 minutes
        echo >> usb_prep.log  No  = STOP - Update USB-Drive with Total Commander Synchronize Dirs Asymmetric
        echo.>> usb_prep.log
  IF EXIST u_script\Msg_Exist_LS.vbs (
     FOR /F "tokens=*" %%A IN ('CSCRIPT.EXE //NoLogo u_script\Msg_Exist_LS.vbs') DO SET Conf=%%A
     IF "!Conf!"=="7" SET Confirm=n
  ) ELSE (
    SET /P Confirm= Overwrite USB-Drive with XP Source Files, Continue ?  Please enter y/n: 
  )
  IF /I !Confirm!.==n. GOTO _end_mig
)


IF EXIST %usbdrive%\SETUPLDR.BIN (
   ATTRIB -h -r -s %usbdrive%\SETUPLDR.BIN
   copy /y %usbdrive%\SETUPLDR.BIN %usbdrive%\SETUPLDR_BIN.bak | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
)

IF EXIST %usbdrive%\txtsetup.sif (
   ATTRIB -h -r -s %usbdrive%\txtsetup.sif
   copy /y %usbdrive%\txtsetup.sif %usbdrive%\txtsetup_sif.bak | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
)

ECHO.
ECHO  Date = !DATE! !TIME:~0,8!
ECHO  $WIN_NT$.~BT Folder                 Copy to USB-Drive is Running ....
ECHO  Please Wait about 5 minutes .....   STOP with [Ctrl][C] 
echo >> usb_prep.log $WIN_NT$.~BT Folder   Copy to USB-Drive Begin   Date = !DATE! !TIME:~0,8!
xcopy %usb_temp%\$WIN_NT$.~BT\*.* %usbdrive%\$WIN_NT$.~BT\ /i /k /e /y /h | tee.bat -a usb_prep.log
echo >> usb_prep.log $WIN_NT$.~BT Folder   Copy to USB-Drive Ready   Date = !DATE! !TIME:~0,8!
ECHO.>> usb_prep.log
echo.
echo  $WIN_NT$.~BT Folder   Copy to USB-Drive Ready
ECHO.
xcopy %usb_temp%\txtsetup.sif %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.
xcopy %usb_temp%\setupldr.bin %usbdrive%\ /y /r /h | tee.bat -a usb_prep.log
ECHO.>> usb_prep.log
ECHO.

IF EXIST %usb_temp%\OEM\nul (
   xcopy %usb_temp%\OEM\*.* %usbdrive%\OEM\ /i /k /e /y /h | tee.bat -a usb_prep.log
   echo >> usb_prep.log OEM Folder Copy to USB-Drive Ready
   echo.>> usb_prep.log
)

ECHO.
ECHO  Copy XPSOURCE folders cmpnents and i386 to USB-Drive Folder $WIN_NT$.~LS
ECHO.
IF "%logtype%" == "Simple" (
  echo >> usb_prep.log Copy XPSOURCE Folders cmpnents and i386 - Begin   Date = !DATE! !TIME:~0,8!
  xcopy %xpsource%\i386\*.* %usbdrive%\$WIN_NT$.~LS\I386\ /i /k /e /y /h
  IF EXIST %xpsource%\cmpnents\nul (
     xcopy %xpsource%\cmpnents\*.* %usbdrive%\$WIN_NT$.~LS\cmpnents\ /i /k /e /y /h
  )
  echo >> usb_prep.log Copy XPSOURCE Folders cmpnents and i386 - Ready   Date = !DATE! !TIME:~0,8!
  echo >> usb_prep.log
) ELSE (
  ECHO.
  ECHO  Date = !DATE! !TIME:~0,8!     
  ECHO  Copy XPSOURCE folders cmpnents and i386 is Running .... 
  ECHO  Please Wait about 15 minutes .....  STOP with [Ctrl][C] 
  echo.>> usb_prep.log
  echo >> usb_prep.log Copy XPSOURCE Folders cmpnents and i386 - Begin   Date = !DATE! !TIME:~0,8!
  xcopy %xpsource%\i386\*.* %usbdrive%\$WIN_NT$.~LS\I386\ /i /k /e /y /h | tee.bat -a usb_prep.log
  IF EXIST %xpsource%\cmpnents\nul (
     xcopy %xpsource%\cmpnents\*.* %usbdrive%\$WIN_NT$.~LS\cmpnents\ /i /k /e /y /h | tee.bat -a usb_prep.log
  )
  echo >> usb_prep.log Copy XPSOURCE Folders cmpnents and i386 - Ready   Date = !DATE! !TIME:~0,8!
  echo.>> usb_prep.log
)

ECHO.
echo  Copy XPSOURCE Folders cmpnents and i386 to Folder $WIN_NT$.~LS - Ready
ECHO.

IF EXIST %xpsource%\I386\presetup.cmd (
   ECHO  Making Backup of presetup.cmd for BTS DriverPacks ....
   copy /y %usbdrive%\$WIN_NT$.~LS\I386\presetup.cmd %usbdrive%\$WIN_NT$.~LS\I386\presetup_cmd.bak | tee.bat -a usb_prep.log
   ECHO.>> usb_prep.log
)

  xcopy %usb_temp%\$WIN_NT$.~LS\*.* %usbdrive%\$WIN_NT$.~LS\ /i /k /e /y /h /r | tee.bat -a usb_prep.log
  ECHO.


ECHO.
ECHO  Making of LocalSource folder $WIN_NT$.~LS Ready
ECHO.
( 
  ECHO.
  ECHO  Making of LocalSource folder $WIN_NT$.~LS Ready
  ECHO.
) >> usb_prep.log

ECHO.
ECHO  FileCopy to USB-Drive is Ready - Date = %DATE% %TIME:~0,8%
ECHO >> usb_prep.log FileCopy to USB-Drive is Ready - Date = %DATE% %TIME:~0,8%
ECHO.


:: ================== Change migrate.inf ====================================================================================

:_end_mig

SET Confirm=y
if EXIST %usbdrive%\$WIN_NT$.~BT\nul (
  ECHO  Make USB-stick in XP Setup to be Preferred Boot Drive U:  Enter: y
  ECHO  Update by Making New migrate.inf with MkMigrateInf2.cmd
  ECHO.
  ECHO  For Mixed SATA / PATA Config: Don't change migrate.inf    Enter: n
  ECHO  For Bootable USB-Harddisk   : Don't change migrate.inf
  ECHO.
  IF EXIST u_script\Msg_Migrate.vbs (
     FOR /F "tokens=*" %%A IN ('CSCRIPT.EXE //NoLogo u_script\Msg_Migrate.vbs') DO SET Conf=%%A
     IF "!Conf!"=="6" SET Confirm=y
     IF "!Conf!"=="7" SET Confirm=n
  ) ELSE (
    SET /P Confirm= Please enter y/n: 
  )

  IF /I !Confirm!.==y. (
     echo.>> usb_prep.log
     copy /y %usbdrive%\$WIN_NT$.~BT\migrate.inf %usbdrive%\$WIN_NT$.~BT\migrate_inf_bak.txt | tee.bat -a usb_prep.log
     CALL makebt\MkMigrateInf2.cmd %usbdrive% %usbdrive%\$WIN_NT$.~BT\migrate.inf
     echo.>> usb_prep.log
     echo >> usb_prep.log USB-Drive becomes Boot Drive U: - MkMigrateInf2 Ready
     echo.>> usb_prep.log
  ) 
)
ECHO.

:: ==========================================================================================================================

:_end_quit
(
  ECHO  ============================================================================= 
  ECHO  *** HELP for Using MultiBoot USB-Drive *** Read Help_USB_MultiBoot2.txt File
  ECHO  Use Notepad to Edit boot.ini on USB-Drive according to Available Boot Options
  ECHO  Boot with USB-Drive plugged and Press [Delete] to Enter BIOS Setup
  ECHO  Change BIOS Boot Settings: 
  ECHO  Harddisk is First Boot Device Type and USB-Drive is seen as First Harddisk
  ECHO  Reboot from USB-Drive and Make Selection from Boot Menu
  ECHO  ============================================================================= 
  ECHO  ***** HELP for Using USB-Drive for Install of Windows XP: *****
  ECHO. 
  ECHO  Reboot from USB-Drive and Select  1. TXT Mode Setup Windows XP
  ECHO  Use Only C: Drive of Computer Harddisk as Partition for Install of Windows XP
  ECHO  and then Select Quick Format with NTFS FileSystem, XP Install is Automatic
  ECHO. 
  ECHO  ***** NEVER UNPLUG USB-Drive ***** Until After First Logon of Windows XP
  ECHO.
  ECHO  New Harddisk and Creating Partitions after Booting from USB-Drive:
  ECHO  Direct after Deleting and Creating New partitions, Quit XP Setup with F3 
  ECHO  OR Switch OFF your Computer and Boot in any case from USB-Drive again and 
  ECHO  Run 1. TXT Mode Setup again so that DriveLetters get their Correct Value
  ECHO  So in this case one Boots ** TWICE ** in the TXT-mode Setup
  ECHO. 
  ECHO  End Program - USB_MultiBoot2.CMD will be Closed - Date = %DATE% %TIME:~0,8%
  ECHO.
) | tee.bat -a usb_prep.log

pause
EXIT

:: ==========================================================================================================================
:: ====================================== END USB_MultiBoot2.cmd ============================================================
:: ==========================================================================================================================
